<template>
  <div class="component-container">
    <lenna-modal ref="lennaModal"></lenna-modal>
    <!-- <lenna-loading v-show="isLoading"></lenna-loading> -->
    <div>
      <h3 class="text-primary">Integrate with Telegram</h3>
      <hr>
      <form @click.prevent>
        <div class="form-group">
          <span
            class="text-muted"
          >Fill in the credentials below, you can get it from @botfather telegram bot.</span>
        </div>

        <div class="form-group row">
          <strong class="col-sm-10 col-form-label">Bot Token</strong>
          <div class="col-sm-10">
            <input
              name="bot token"
              v-validate="'required'"
              class="form-control"
              v-model="form.botToken"
              placeholder="Bot Token"
            >
            <span class="text-danger">{{ errors.first('bot token') }}</span>
          </div>
          <div class="col-sm-2">
            <button class="btn h-100 btn-rounded btn-primary" @click="getBotProfile">Check</button>
          </div>
        </div>
        <br>

        <div class="form-group row">
          <strong class="col-sm-12 col-form-label">Bot Name</strong>
          <div class="col-sm-10">
            <input
              type="text"
              name="bot name"
              v-validate="'required'"
              class="form-control"
              id="webhook-url"
              v-model="form.botName"
              placeholder="Bot Name"
              readonly
            >
            <span class="text-danger">{{ errors.first('bot name') }}</span>
          </div>
        </div>
        <div class="form-group row">
          <strong class="col-sm-12 col-form-label">Bot Username</strong>
          <div class="col-sm-10">
            <input
              type="text"
              name="bot username"
              v-validate="'required'"
              class="form-control"
              id="webhook-url"
              v-model="form.botUsername"
              placeholder="Bot Username"
              readonly
            >
            <span class="text-danger">{{ errors.first('bot username') }}</span>
          </div>
        </div>
        <br>
        <div class="form-group row">
          <input type="hidden" v-model="form.status">
          <div class="col-sm-6">
            <button
              type="button"
              class="btn btn-rounded btn-block"
              :class="(!form.status) ? 'btn-secondary': 'btn-danger'"
              :disabled="!form.status"
              @click="disconnectChannel"
            >Disconnect</button>
          </div>
          <div class="col-sm-6">
            <button
              type="button"
              @click="submitForm"
              class="btn btn-rounded btn-block btn-primary"
            >{{(form.status) ? 'Update': 'Connect'}}</button>
          </div>
        </div>
      </form>
    </div>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";
export default {
  data() {
    return {
      form: {
        botToken: "",
        botUsername: "",
        botName: "",
        status: false,
        channelName: "telegram"
      }
    };
  },
  computed: {
    webhookUrl() {
      //   return "https://21988a9f.ngrok.io"+"/app/public/api/"+this.$store.getters.appId.hashed+'/webhook/telegram'
      return (
        this.baseUrl +
        "/api/" +
        this.$store.getters.appId.hashed +
        "/webhook/telegram"
      );
    }
  },
  methods: {
    async getBotProfile() {
      try {
        let endpoint = "https://api.telegram.org/bot{bot-token}/getMe";
        endpoint = endpoint.replace("{bot-token}", this.form.botToken);
        let response = await this.$axios.get(endpoint);
        response = response.data;

        this.form.botName = response.result.first_name;
        this.form.botUsername = response.result.username;
        return true;
      } catch (error) {
        return false;
      }
    },
    async disconnectChannel() {
      try {
        let data = {
          channelName: this.form.channelName,
          status: false
        };
        let response = await this.$axios.put(
          `api/${this.$store.getters.appId.hashed}/integrate/update`,
          data
        );
        response = response.data;

        this.$refs.lennaModal.show("info", "Success", response.message);

        this.form.status = false;
        EventBus.$emit("toggleStatusMain", "telegram");
      } catch (error) {
        this.form.status = !this.form.status;
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          error.response.data.message
        );
      }
    },
    async submitForm() {
      let validated = await this.$validator.validateAll();

      let response = await this.getBotProfile();
      if (response) {
        try {
          let formData = {
            ...this.form,
            status: true,
            webhookUrl: this.webhookUrl
          };
          let response = await this.$axios.post(
            `api/${this.$store.getters.appId.hashed}/integrate`,
            formData
          );
          this.form.status = true;

          this.$refs.lennaModal.show("info", "Success", response.data.message);

          EventBus.$emit("toggleStatusMain", "telegram");
        } catch (error) {
          this.$refs.lennaModal.show(
            "alert",
            "Sorry",
            error.response.data.message
          );
        }
      } else {
        this.$refs.lennaModal.show("alert", "Sorry", "Invalid bot token");
      }
    },
    async fetchData() {
      let response = await this.$axios.get(
        `api/${this.$store.getters.appId.hashed}/integrate`
      );
      response = response.data;
      let channelData = response.data.find(function(item) {
        return item.name == "telegram";
      }).integration;

      if (channelData != null) {
        this.form.botToken = channelData.integration_data.botToken;
        this.form.botUsername = channelData.integration_data.botUsername;
        this.form.botName = channelData.integration_data.botName;
        this.form.status = channelData.status;
      }
    }
  },
  mounted() {
    this.fetchData();

    EventBus.$on("toggleStatus", value => {
      this.fetchData();
    });
  }
};
</script>
<style lang="scss">
.component-container {
  position: relative;
}
</style>
